module top(
	input Reset,
	input [7:0] A,
	output [7:0] Y
);

	// Generator sygnau zegarowego
	wire Clock;
	OSCH #(
		.NOM_FREQ("133.00")
	) OSCH_inst(
		.STDBY(1'b0),
		.OSC(Clock),
		.SEDSTDBY()
	);
	
	// Synchronizacja wej
	reg [7:0] A_temp;
	reg [7:0] A_sync;
	always @(posedge Clock, negedge Reset) begin
		if(!Reset) begin
			A_temp <= 0;
			A_sync <= 0;
		end else begin
			A_temp <= A;
			A_sync <= A_temp;
		end
	end
	
	// Czasochonna operacja
	// 119.303MHz is the maximum frequency for this preference.
	
	reg [7:0] Temp;
	always @(posedge Clock, negedge Reset) begin
		if(!Reset)
			Temp <= 0;
		else
			Temp <= ((((A_sync ^ 8'b10101010) + 8'd123) * 8'd100) * A_sync) + A_sync;
	end
	assign Y = Temp;
	
	
	// Pipelinig
	// 167.870MHz is the maximum frequency for this preference.
	/*
	reg [7:0] Temp1;
	reg [7:0] Temp2;
	reg [7:0] Temp3;
	reg [7:0] Temp4;
	reg [7:0] Temp5;
	always @(posedge Clock, negedge Reset) begin
		if(!Reset) begin
			Temp1 <= 0;
			Temp2 <= 0;
			Temp3 <= 0;
			Temp4 <= 0;
			Temp5 <= 0;
		end else begin
			Temp1 <= A_sync ^ 8'b10101010;
			Temp2 <= Temp1 + 8'd123;
			Temp3 <= Temp2 * 8'd100;
			Temp4 <= Temp3 * A_sync;
			Temp5 <= Temp4 + A_sync;
		end
	end
	
	assign Y = Temp5;
	*/
	

endmodule
